<?php
declare(strict_types=1);

namespace Inti\Wp\Helpers\Provider;

/**
 * Interface ProviderListInterface
 *
 * @package Inti\Wp\Helpers\Provider
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp-helpers
 */
interface ProviderListInterface
{
    public function canProvide(string $name, ?string $type = null): bool;
    public function getProvider(string $name, ?string $type = null): ?ProviderInterface;

    /**
     * @param string|null $type
     * @return ProviderInterface[]
     */
    public function getProviders(?string $type = null): array;
}
